<?php
namespace Indeterminado\Repositories;

use Setforms2\Runtime\Connection;

class Obshistfilial extends \Doctrine\ORM\EntityRepository
{

    /**
     * Método que realiza a inserção de Observação da Unidade na tabela
     * OBSHISTFILIAL.
     * A necessidade de criar um método para este fim surgiu da existência,
     * na tabela de um campo do tipo BLOB, que requer um tratamento especial tanto
     * no momento da busca quanto na inserção.
     *
     * @param $cdfilial
     * @param $dthistfil
     * @param $cdoperador
     * @param $cddescobsfilial
     * @param $dsobshistfilial
     * @param $nrorg
     * @param $dtinclusao
     * @param $dtultatu
     * @param $nrorginclusao
     * @param $cdoperinclusao
     * @param $nrorgultatu
     * @param $cdoperultatu
     * @param $idativo
     *
     * @return null
     * @throws \Exception
     */
    public static function insereObshistfilial(
        $cdfilial, $dthistfil, $cdoperador, $cddescobsfilial, $dsobshistfilial,
        $nrorg, $dtinclusao, $dtultatu, $nrorginclusao, $cdoperinclusao,
        $nrorgultatu, $cdoperultatu, $idativo
    )
    {
        $query = "INSERT INTO OBSHISTFILIAL
                  (
                    CDFILIAL,
                    DTHISTFIL,
                    CDOPERADOR,
                    CDDESCOBSFILIAL,
                    DSOBSHISTFILIAL,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDATIVO
                  )
                  VALUES
                  (
                    :CDFILIAL,
                    :DTHISTFIL,
                    :CDOPERADOR,
                    :CDDESCOBSFILIAL,
                    utl_raw.cast_to_raw(:DSOBSHISTFILIAL),
                    :NRORG,
                    :DTINCLUSAO,
                    :DTULTATU,
                    :NRORGINCLUSAO,
                    :CDOPERINCLUSAO,
                    :NRORGULTATU,
                    :CDOPERULTATU,
                    :IDATIVO
                  )
            ";
        $params = array(
            'CDFILIAL'        => $cdfilial,
            'DTHISTFIL'       => $dthistfil,
            'CDOPERADOR'      => $cdoperador,
            'CDDESCOBSFILIAL' => $cddescobsfilial,
            'DSOBSHISTFILIAL' => $dsobshistfilial,
            'NRORG'           => $nrorg,
            'DTINCLUSAO'      => $dtinclusao,
            'DTULTATU'        => $dtultatu,
            'NRORGINCLUSAO'   => $nrorginclusao,
            'CDOPERINCLUSAO'  => $cdoperinclusao,
            'NRORGULTATU'     => $nrorgultatu,
            'CDOPERULTATU'    => $cdoperultatu,
            'IDATIVO'         => $idativo
        );

        try {
            $conn = Connection::getInstance();
            $conn->execute($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    /**
     * Método que realiza a inserção de Observação da Unidade na tabela
     * OBSHISTFILIAL.
     * A necessidade de criar um método para este fim surgiu da existência,
     * na tabela de um campo do tipo BLOB, que requer um tratamento especial tanto
     * no momento da busca quanto na inserção.
     *
     * @param $cdfilial
     * @param $dthistfil
     * @param $cdoperador
     * @param $cddescobsfilial
     * @param $dsobshistfilial
     * @param $nrorg
     * @param $dtinclusao
     * @param $dtultatu
     * @param $nrorginclusao
     * @param $cdoperinclusao
     * @param $nrorgultatu
     * @param $cdoperultatu
     * @param $idativo
     *
     * @return null
     * @throws \Exception
     */
    public static function atualizaObshistfilial(
        $cdfilial, $dthistfil, $cdoperador, $cddescobsfilial, $dsobshistfilial,
        $nrorg, $dtinclusao, $dtultatu, $nrorginclusao, $cdoperinclusao,
        $nrorgultatu, $cdoperultatu, $idativo
    )
    {
        $query = "UPDATE OBSHISTFILIAL
                     SET DSOBSHISTFILIAL   = utl_raw.cast_to_raw(:DSOBSHISTFILIAL),
                         DTINCLUSAO        = :DTINCLUSAO,
                         DTULTATU          = :DTULTATU,
                         NRORGINCLUSAO     = :NRORGINCLUSAO,
                         CDOPERINCLUSAO    = :CDOPERINCLUSAO,
                         NRORGULTATU       = :NRORGULTATU,
                         CDOPERULTATU      = :CDOPERULTATU,
                         IDATIVO           = :IDATIVO
                   WHERE CDFILIAL          = :CDFILIAL
                     AND DTHISTFIL         = :DTHISTFIL
                     AND CDOPERADOR        = :CDOPERADOR
                     AND CDDESCOBSFILIAL   = :CDDESCOBSFILIAL
                     AND NRORG             = :NRORG
            ";
        $params = array(
            'DSOBSHISTFILIAL' => $dsobshistfilial,
            'DTINCLUSAO'      => $dtinclusao,
            'DTULTATU'        => $dtultatu,
            'NRORGINCLUSAO'   => $nrorginclusao,
            'CDOPERINCLUSAO'  => $cdoperinclusao,
            'NRORGULTATU'     => $nrorgultatu,
            'CDOPERULTATU'    => $cdoperultatu,
            'IDATIVO'         => $idativo,
            'CDFILIAL'        => $cdfilial,
            'DTHISTFIL'       => $dthistfil,
            'CDOPERADOR'      => $cdoperador,
            'CDDESCOBSFILIAL' => $cddescobsfilial,
            'NRORG'           => $nrorg,
        );

        try {
            $conn = Connection::getInstance();
            $conn->execute($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

}