create or replace
PROCEDURE ETL_FINANCEIROGER_RAT
                                    (P_DTINI      IN DATE,
                                     P_DTFINA     IN DATE)
   IS
   V_DTFIM           DATE;
   V_DTINI           DATE;
   V_DTMOV           VARCHAR2(10);
   V_DTPROC          VARCHAR2(10);
   V_DTPROCES	       VARCHAR2(10);
   V_MES             VARCHAR2(02);
   V_ANO             VARCHAR2(04);
   V_BIM             VARCHAR2(06);
   V_TRI             VARCHAR2(06);
   V_SEM             VARCHAR2(06);

   V_COUNTER       NUMBER  NOT NULL := 0;
BEGIN

  V_MES  :=  TO_CHAR(P_DTINI,'MM');
  V_ANO  :=  TO_CHAR(P_DTINI,'YYYY');

  DELETE FROM ETLCONTAPAGRAT
  WHERE (CDANOBI >= V_ANO)
   AND (CDMESBI >= V_MES);
  COMMIT;

  DELETE FROM ETLCONTARECRAT
  WHERE (CDANOBI >= V_ANO)
  AND (CDMESBI >= V_MES);
  COMMIT;

  V_DTINI := TO_DATE('01'||TO_CHAR(P_DTINI,'MMYYYY'),'DDMMYYYY');

  WHILE (V_DTINI  <=  P_DTFINA) LOOP
    V_DTFIM := LAST_DAY( V_DTINI);

    FOR C_ETL IN
      (SELECT F.CDFILIAL, F.DTINICIALBI,  F.CDEMPRESA
       FROM  FILIAL F
       WHERE F.IDFUNCAOFILI IS NULL    --Desconsidera Regionais e Operadores Logsticos
       AND F.DTINICIALBI IS NOT NULL   --Desconsidera Filiais Sem Data de BI cadastrada
      )
    LOOP

      IF TO_DATE('01'||TO_CHAR(C_ETL.DTINICIALBI,'MMYYYY'),'DDMMYYYY') <= V_DTINI THEN  --Incio da condio por data de BI

      V_MES := TO_CHAR(V_DTFIM,'MM');
      V_ANO := TO_CHAR(V_DTFIM,'YYYY');
      V_BIM := TO_CHAR(TRUNC((V_MES - 1) / 2) + 1)||' Bim';
      V_TRI := TO_CHAR(TRUNC((V_MES - 1) / 3) + 1)||' Tri';
      V_SEM := TO_CHAR(TRUNC((V_MES - 1) / 6) + 1)||' Sem';

      FOR C_PAGAR IN
         (SELECT CDFILIAL,
                 CDFILIRECE,
                 CDFILIRAT,
                 NMCENTCUST,
                 CDFORNECED,
                 CDEMPRESA,
                 CDTPCTPAGAR,
                 CDCLASSFINA,
                 DTENTRSAID,
                 (VRORIGINAL) AS VRORIG,
                 (VRLIQPAG)   AS VRLIQPAG,
                 (VRAVENCER)  AS VRAVENCER,
                 (VRVENCIDAS) AS VRVENCIDAS,
                 (VRBAIXADO)  AS VRBAIXADO,
                 (VRPREV)     AS VRPREV,
                 (VRCTABERTO) AS VRCTABERTO
            FROM (SELECT DISTINCT CP.CDFILIAL,
                        NF.CDFILIRECE,
                        RT.CDFIRATCTPAG AS CDFILIRAT,
                        CC.NMCENTCUST,
                        NF.CDFORNECED,
                        CP.CDEMPRESA,
                        CP.CDTPCTPAGAR,
                        CP.CDCLASSFINA,
                        NF.DTENTRSAID,
                        (NVL((CP.VRORIGPAG * ((RT.VRRATCCCTPAG*100)/CP.VRATUAPAG) /100),0)) AS VRORIGINAL,
                        (NVL((CP.VRORIGPAG * ((RT.VRRATCCCTPAG*100)/CP.VRORIGPAG) /100),0)) AS VRLIQPAG,
                        (NVL(CASE WHEN TRUNC(CP.DTATUAVENPAG)  >= TRUNC(SYSDATE) THEN (CP.VRORIGPAG * ((RT.VRRATCCCTPAG*100)/CP.VRORIGPAG) /100) END,0)) AS VRAVENCER,
                        (NVL(CASE CP.IDSTATPAG WHEN 'A' THEN (CASE WHEN (CP.DTATUAVENPAG)  < TRUNC(SYSDATE) THEN (CP.VRORIGPAG * ((RT.VRRATCCCTPAG*100)/CP.VRORIGPAG) /100) END) END, 0)) AS VRVENCIDAS,
                        (DECODE(CP.IDSTATPAG, 'B', (CP.VRORIGPAG * ((RT.VRRATCCCTPAG*100)/CP.VRORIGPAG) /100), 0)) AS VRBAIXADO,
                        (DECODE(NF.IDSTATUS,  'V', (CP.VRORIGPAG * ((RT.VRRATCCCTPAG*100)/CP.VRORIGPAG) /100), 0)) AS VRPREV,
                        (DECODE(CP.IDSTATPAG, 'A', (CP.VRORIGPAG * ((RT.VRRATCCCTPAG*100)/CP.VRORIGPAG) /100), 0))  AS VRCTABERTO
                    FROM CONTAPAGAR CP, NOTAFISCAL NF,
                         TIPOOPERAC OP, RATCTPAGAR RT, CENTCUST CC
                   WHERE CP.CDFILIAL = NF.CDFILIAL
                     AND CP.NRLANCTONF = NF.NRLANCTONF
                     AND TRUNC(NF.DTENTRSAID) BETWEEN TRUNC(V_DTINI) AND TRUNC(V_DTFIM)
                     AND CP.CDFILIAL = C_ETL.CDFILIAL
                     AND RT.CDFILIAL = CP.CDFILIAL(+)
                     AND RT.NRLANCTONF = CP.NRLANCTONF(+)
                     AND RT.NRPARCELAPAG = CP.NRPARCELAPAG(+)
                     AND RT.NRSEQVENPAG = CP.NRSEQVENPAG(+)
                     AND CP.CDEMPRESA IS NOT NULL
                     AND CP.VRATUAPAG > 0
                     AND NOT(NF.IDSTATUS IN('C','G','P','R'))
                     AND OP.CDTIPOOPER = NF.CDTIPOOPER
                     AND NF.IDENTRSAIDOP = 'E'
					 AND RT.CDCENTCUST = CC.CDCENTCUST)
         )
      LOOP

           V_DTMOV := TO_CHAR(C_PAGAR.DTENTRSAID, 'DD/MM/YYYY');
           V_DTPROC:= TO_CHAR(SYSDATE,'DD/MM/YYYY');

           INSERT INTO ETLCONTAPAGRAT
             (
              /*DIMENSES*/
              CDANOBI     , CDMESBI     , BIETLPAG     , TRETLPAG     , SEETLPAG     ,
              CDFILIAL    , CDFILIRECE  , CDFILIRAT    , NMCENTCUST   , CDFORNECED   ,
              CDEMPRESA   , CDTPCTPAGAR , CDCLASSFINA  , DSDTETLMOVPAG, DSDTPROCESETL,

              /*FATOS*/
              VRETLORIGPAG   , VRETLLIQPAG , VRETLAVENCERPAG, VRETLVENCIDAPAG,
              VRETLBAIXADOPAG, VRETLPREVPAG, VRETLCTABERTOPAG)
           VALUES
             (
              /*DIMENSES*/
              V_ANO            , V_MES              , V_BIM              , V_TRI             , V_SEM             ,
              C_ETL.CDFILIAL   , C_PAGAR.CDFILIRECE , C_PAGAR.CDFILIRAT  , C_PAGAR.NMCENTCUST, C_PAGAR.CDFORNECED,
              C_PAGAR.CDEMPRESA, C_PAGAR.CDTPCTPAGAR, C_PAGAR.CDCLASSFINA, V_DTMOV           , V_DTPROC          ,

              /*FATOS*/
              C_PAGAR.VRORIG   , C_PAGAR.VRLIQPAG   , C_PAGAR.VRAVENCER  , C_PAGAR.VRVENCIDAS,
              C_PAGAR.VRBAIXADO, C_PAGAR.VRPREV     , C_PAGAR.VRCTABERTO);

           V_COUNTER := V_COUNTER+1;

           IF V_COUNTER >= 500 THEN
             COMMIT;
             V_COUNTER := 0;
           END IF;

        END LOOP;

       V_COUNTER := 0;

       FOR C_RECEB IN
         (SELECT CDFILIAL,
                 CDFILIEMIT,
                 CDFILIRAT,
                 NMCENTCUST,
                 CDCLIENTE,
                 CDEMPRESA,
                 CDTPCTRECEB,
                 CDCLASSFINA,
                 DTENTRSAID,
                 (VRORIGINAL) AS VRORIG,
                 (VRLIQREC)   AS VRLIQREC,
                 (VRAVENCER)  AS VRAVENCER,
                 (VRVENCIDAS) AS VRVENCIDAS,
                 (VRBAIXADO)  AS VRBAIXADO,
                 (VRPREVISTO) AS VRPREVISTO,
                 (VRCTABERTO) AS VRCTABERTO
            FROM (SELECT DISTINCT CR.CDFILIAL,
                        NF.CDFILIEMIT,
                        RT.CDFIRATCTREC AS CDFILIRAT,
                        CC.NMCENTCUST,
                        NF.CDCLIENTE,
                        CR.CDEMPRESA,
                        CR.CDTPCTRECEB,
                        CR.CDCLASSFINA,
                        NF.DTENTRSAID,
                        (NVL(CR.VRORIGREC * ((RT.VRRATCCCTREC*100)/CR.VRATUAREC) /100,0)) AS VRORIGINAL,
                        (NVL(CR.VRORIGREC * ((RT.VRRATCCCTREC*100)/CR.VRORIGREC) /100,0)) AS VRLIQREC,
                        (NVL(CASE WHEN TRUNC(CR.DTATUAVENREC)  >= TRUNC(SYSDATE) THEN (CR.VRORIGREC * ((RT.VRRATCCCTREC*100)/CR.VRORIGREC) /100) END,0)) AS VRAVENCER,
                        (NVL(CASE CR.IDSTATREC WHEN 'A' THEN (CASE WHEN (CR.DTATUAVENREC)  < TRUNC(SYSDATE) THEN (CR.VRORIGREC * ((RT.VRRATCCCTREC*100)/CR.VRORIGREC) /100) END) END, 0)) AS VRVENCIDAS,
                        (DECODE(CR.IDSTATREC, 'B', (CR.VRORIGREC * ((RT.VRRATCCCTREC*100)/CR.VRORIGREC) /100), 0)) AS VRBAIXADO,
                        (DECODE(NF.IDSTATUS,  'V', (CR.VRORIGREC * ((RT.VRRATCCCTREC*100)/CR.VRORIGREC) /100), 0)) AS VRPREVISTO,
                        (DECODE(CR.IDSTATREC, 'A', (CR.VRORIGREC * ((RT.VRRATCCCTREC*100)/CR.VRORIGREC) /100), 0)) AS VRCTABERTO
                    FROM CONTARECEBER CR, NOTAFISCAL NF,
                         TIPOOPERAC OP, RATCTRECEBER RT, CENTCUST CC
                   WHERE CR.CDFILIAL = NF.CDFILIAL
                     AND CR.NRLANCTONF = NF.NRLANCTONF
                     AND TRUNC(NF.DTENTRSAID) BETWEEN TRUNC(V_DTINI) AND TRUNC(V_DTFIM)
                     AND NF.CDFILIAL = C_ETL.CDFILIAL
                     AND RT.CDFILIAL = CR.CDFILIAL(+)
                     AND RT.NRLANCTONF  = CR.NRLANCTONF(+)
                     AND RT.NRSEQVENREC = CR.NRSEQVENREC(+)
                     AND RT.NRPARCELAREC  = CR.NRPARCELAREC(+)
                     AND CR.CDEMPRESA IS NOT NULL
                     AND CR.VRATUAREC > 0
                     AND NOT(NF.IDSTATUS IN('C','G','P','R'))
                     AND OP.CDTIPOOPER = NF.CDTIPOOPER
                     AND NF.IDENTRSAIDOP = 'S'
					 AND RT.CDCENTCUST = CC.CDCENTCUST)
            )

          LOOP

             V_DTMOV := TO_CHAR(C_RECEB.DTENTRSAID, 'DD/MM/YYYY');
             V_DTPROCES := TO_CHAR(SYSDATE, 'DD/MM/YYYY');

             INSERT INTO ETLCONTARECRAT
               (
                /*DIMENSES*/
                CDANOBI   , CDMESBI     , BIETLREC   , TRETLREC     , SEETLREC     ,
                CDFILIAL  , CDFILIEMIT  , CDFILIRAT  , NMCENTCUST   , CDCLIENTE    ,
                CDEMPRESA , CDTPCTRECEB , CDCLASSFINA, DSDTETLMOVREC, DSDTPROCESETL,

                /*FATOS*/
                VRETLORIGREC   , VRLIQREC     , VRETLAVENCERREC, VRETLVENCIDAREC,
                VRETLBAIXADOREC, VRETLPREVISTOREC, VRETLCTABERTOREC)

             VALUES
               (
               /*DIMENSES*/
                V_ANO              , V_MES              , V_BIM              , V_TRI             ,             V_SEM,
                C_ETL.CDFILIAL     , C_RECEB.CDFILIEMIT , C_RECEB.CDFILIRAT  , C_RECEB.NMCENTCUST, C_RECEB.CDCLIENTE,
                C_RECEB.CDEMPRESA  , C_RECEB.CDTPCTRECEB, C_RECEB.CDCLASSFINA, V_DTMOV           ,        V_DTPROCES,

                /*FATOS*/
                C_RECEB.VRORIG   ,C_RECEB.VRLIQREC   , C_RECEB.VRAVENCER, C_RECEB.VRVENCIDAS,
                C_RECEB.VRBAIXADO, C_RECEB.VRPREVISTO, C_RECEB.VRCTABERTO);

             V_COUNTER:= V_COUNTER+1;

             IF V_COUNTER >= 500 THEN
               COMMIT;
               V_COUNTER := 0;
             END IF;

         END LOOP;
      END IF;
    END LOOP;
    COMMIT;
    V_DTINI := ADD_MONTHS(V_DTINI,1);
  END LOOP;
END;

/


DECLARE
   V_CDSEQUENCIAL VARCHAR2(20) NULL;
BEGIN
    SELECT COUNT(*)
    INTO   V_CDSEQUENCIAL
    FROM   EVENTOAEV 
    WHERE  NMOBJBDEVEN = 'ETL_FINANCEIROGER_RAT';
    
    IF V_CDSEQUENCIAL = 0 THEN     --> S ADICIONA A PROCEDURE SE ELA NO EXISTIR AINDA NO CADASTRO
        BEGIN
            SELECT LPAD(NVL(MAX(LPAD(CDEVENTOAEV,10,'0'))+1,0),10,'0')
            INTO   V_CDSEQUENCIAL
            FROM   EVENTOAEV;
        
            INSERT INTO EVENTOAEV 
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
            VALUES
            (V_CDSEQUENCIAL,'Contas do Financeiro Rateado','STP',NULL,SYSDATE,'ETL_FINANCEIROGER_RAT');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTINI','D','E','Data Inicial','N',0,'01');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTFINA','D','E','Data Final','N',0,'02');
        
            COMMIT;
        EXCEPTION
           WHEN OTHERS THEN
              RAISE_APPLICATION_ERROR (-20001,'Falha no cadastro de eventos agendveis.');
        END;
    END IF;
END;
/


BEGIN                                       

   CRIA_FATOS('ETLCONTAPAGRAT', 'VRETLORIGPAG'		,'Vr. Original'			,'Valor Original'			,'Rateios Contas a Pagar');
   CRIA_FATOS('ETLCONTAPAGRAT', 'VRETLLIQPAG'		,'Vr. Lquido'				,'Valor Lquido'			,'Rateios Contas a Pagar');
   CRIA_FATOS('ETLCONTAPAGRAT', 'VRETLCTABERTOPAG'	,'Vr. Contas em Aberto'	,'Valor Contas em Aberto'	,'Rateios Contas a Pagar');
   CRIA_FATOS('ETLCONTAPAGRAT', 'VRETLVENCIDAPAG'	,'Vr. Contas Vencidas'		,'Valor Contas Vencidas'	,'Rateios Contas a Pagar');
   CRIA_FATOS('ETLCONTAPAGRAT', 'VRETLAVENCERPAG'	,'Vr. Contas a Vencer'		,'Valor Contas a Vencer'	,'Rateios Contas a Pagar');
   CRIA_FATOS('ETLCONTAPAGRAT', 'VRETLPREVPAG'		,'Vr. Contas Previstas'	,'Valor Contas Previstas'	,'Rateios Contas a Pagar');
   CRIA_FATOS('ETLCONTAPAGRAT', 'VRETLBAIXADOPAG'	,'Vr. Contas Baixadas'		,'Valor Contas Baixadas'	,'Rateios Contas a Pagar');
   
   CRIA_DIME('ETLCONTAPAGRAT',  'CDFILIAL'		,'Filial de Lanamento'			,'FILIAL'		,'CDFILIAL'		,'NMFILIAL'		,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'CDFILIRECE'	,'Filial de origem'				,'FILIAL'		,'CDFILIAL'		,'NMFILIAL'		,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'CDFILIRAT'		,'Filial de Rateio'				,'FILIAL'		,'CDFILIAL'		,'NMFILIAL'		,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'CDEMPRESA'		,'Empresa'						,'EMPRESA'		,'CDEMPRESA'	,'NMEMPRESA'	,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'CDTPCTPAGAR'	,'Tipo de Conta Paga'			,'TIPOCTPAGAR'	,'CDTPCTPAGAR'	,'DSTPCTPAGAR'	,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'CDFORNECED'	,'Fornecedor'					,'FORNECEDOR'	,'CDFORNECED'	,'NMFANTFORN'	,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'CDCLASSFINA'	,'Classificao Financeira'		,'CLASSFINANC'	,'CDCLASSFINA'	,'DSCLASSFINA'	,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'NMCENTCUST'	,'Desc. do Cent. de Cus.'				,NULL			,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'CDANOBI'		,'Ano'							,NULL			,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'CDMESBI'		,'Ms'							,NULL			,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'BIETLPAG'		,'Bimestre'						,NULL			,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'TRETLPAG'		,'Trimestre'					,NULL			,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'SEETLPAG'		,'Semestre'						,NULL			,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'DSDTETLMOVPAG'	,'Data de Entrada'				,NULL			,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTAPAGRAT',  'DSDTPROCESETL'	,'Data de Processamento da ETL'	,NULL			,NULL			,NULL			,NULL);
   
   CRIA_FATOS('ETLCONTARECRAT','VRETLORIGREC'		,'Vlr. Original'			,'Valor Original'			,'Rateios Contas a Receber');
   CRIA_FATOS('ETLCONTARECRAT','VRLIQREC'			,'Vlr. Lquido'				,'Valor Lquido'			,'Rateios Contas a Receber');
   CRIA_FATOS('ETLCONTARECRAT','VRETLCTABERTOREC'	,'Vlr. Contas em Aberto'	,'Valor Contas em Aberto'	,'Rateios Contas a Receber');
   CRIA_FATOS('ETLCONTARECRAT','VRETLAVENCERREC'	,'Vlr. Contas a Vencer'		,'Valor Contas a Vencer'	,'Rateios Contas a Receber');
   CRIA_FATOS('ETLCONTARECRAT','VRETLVENCIDAREC'	,'Vlr. Contas Vencidas'		,'Valor Contas Vencidas'	,'Rateios Contas a Receber');
   CRIA_FATOS('ETLCONTARECRAT','VRETLBAIXADOREC'	,'Vlr. Contas Baixadas'		,'Valor Contas Baixadas'	,'Rateios Contas a Receber');
   CRIA_FATOS('ETLCONTARECRAT','VRETLPREVISTOREC'	,'Vlr. Contas Previstas'	,'Valor Contas Previstas'	,'Rateios Contas a Receber');

   CRIA_DIME('ETLCONTARECRAT'	,'CDFILIAL'		,'Filial de Lanamento'			,'FILIAL'			,'CDFILIAL'		,'NMFILIAL'		,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'CDFILIEMIT'	,'Filial de Origem'				,'FILIAL'			,'CDFILIAL'		,'NMFILIAL'		,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'CDFILIRAT'	,'Filial de Rateio'				,'FILIAL'			,'CDFILIAL'		,'NMFILIAL'		,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'CDEMPRESA'	,'Empresa'						,'EMPRESA'			,'CDEMPRESA'	,'NMEMPRESA'	,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'CDTPCTRECEB'	,'Tipo de Conta Recebida'		,'TIPOCTRECEBER'	,'CDTPCTRECEB'	,'DSTPCTRECEB'	,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'CDCLASSFINA'	,'Classificacao Financeira'		,'CLASSFINANC'		,'CDCLASSFINA'	,'DSCLASSFINA'	,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'CDCLIENTE'	,'Cliente'						,'CLIENTE'			,'CDCLIENTE'	,'NMFANTCLIE'	,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'NMCENTCUST'	,'Desc. do Cent. de Cus.'				,NULL				,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'CDANOBI'		,'Ano'							,NULL				,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'CDMESBI'		,'Ms'							,NULL				,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'BIETLREC'		,'Bimestre'						,NULL				,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'TRETLREC'		,'Trimestre'					,NULL				,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'SEETLREC'		,'Semestre'						,NULL				,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'DSDTETLMOVREC','Data de Sada'				,NULL				,NULL			,NULL			,NULL);
   CRIA_DIME('ETLCONTARECRAT'	,'DSDTPROCESETL','Data de Processamento da ETL'	,NULL				,NULL			,NULL			,NULL);
   COMMIT;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('ETL_FINANCEIROGER_RAT','5.45.xxx'); END;
/