function Sup03600PedidoColetaService(restEngine) {

    this.filtroPedido = function (parametrosFilter) {
        return restEngine.post('sup_cotacao_pedido#/controlePedidoColeta', {
            "requestType": "FilterData",
            "filter": parametrosFilter
        });
    };

    this.swipeProduto = function (parametrosSwipe){
    	return restEngine.post('sup_cotacao_pedido#/produtoPedcol', {
    		"requestType" : "FilterData",
    		"filter": parametrosSwipe
    	});
    };

    this.atualizaPrecObj = function(produtos){
        return restEngine.post('sup_cotacao_pedido#/savePrecObj', {
            "requestType" : "Row",
            "row" : produtos
        });
    };

    this.retornaEmAberto = function(pedidos, dtexpirapedcol){
        return restEngine.post('sup_cotacao_pedido#/updataSituPed', {
            "requestType" : "Row",
            "row" : {
                "PEDIDOS": pedidos,
                "DTEXPIRAPEDCOL": dtexpirapedcol
            }
        });
    };

    this.gravaCotWeb = function(pedidosValidos, entraLista){
        return restEngine.post('sup_cotacao_pedido#/geraCotacaoWeb', {
            "requestType" : "Row",
            "row" : {
                "PEDIDOS": pedidosValidos,
                "LISTAPREC": entraLista
            }
        });
    };
    
    this.enviaEmailFornecedor = function(assunto, mensagem, fornecedores, emailOperador, nmOperador){
        return restEngine.post('sup_cotacao_pedido#/enviaEmailFornecedor', {
            "requestType": "Row",
            "row": {
                "ASSUNTO": assunto,
                "MENSAGEM": mensagem,
                "FORNECEDORES": fornecedores,
                "EMAIL": getLocalVar("EMAIL")
            }
        });
    };
    
    this.defineCookieEmail = function(nome, mensagem) {
        return restEngine.post('sup_cotacao_pedido#/defineCookieEmail', {
            "requestType": "Row",
            "row": {
                "NOME": nome,
                "MENSAGEM": mensagem
            }
        });
    };
    
    this.retornaCookieEmail = function(nome) {
        return restEngine.post('sup_cotacao_pedido#/retornaCookieEmail', {
            "requestType": "Row",
            "row": {
                "NOME": nome
            }
        });
    };
    
    this.retornaMenorMaiorProdutoPedido = function(listaNrpedidocol) {
        return restEngine.post('sup_cotacao_pedido#/retornaMenorMaiorProdutoPedido', {
            "requestType": "Row",
            "row": {
                "FILIALNRPEDIDOCOL": listaNrpedidocol
            }
        });
    };
    
    this.calculaPrecoObjetivo = function(listaNrpedidocol, consideraMarca) {
        return restEngine.post('sup_cotacao_pedido#/calculaPrecoObjetivo', {
            "requestType": "Row",
            "row": {
                "LISTAPEDIDOS": listaNrpedidocol,
                "CONSIDERAMARCA": consideraMarca
            }
        });
    };
    
    this.salvaPrecoObjetivoMinimo = function(listaNrpedidocol, listaProdutos) {
        return restEngine.post('sup_cotacao_pedido#/salvaPrecoObjetivoMinimo', {
            "requestType": "Row",
            "row": {
                "LISTAPEDIDOS": listaNrpedidocol,
                "PRODUTOS": listaProdutos
            }
        });
    };
    
    this.deletaLista = function(nrlista) {
        return restEngine.post('sup_cotacao_pedido#/deletaLista', {
            "requestType": "Row",
            "row": {
                "NRLISTA": nrlista
            }
        });
    };
    
    this.salvarComentario = function(row, info) {
        row.COMPRADOR         = info.COMPRADOR;
        row.EMAIL_RESPONSAVEL = info.EMAIL;
        row.EMAIL_LOGADO      = getLocalVar("EMAIL");
        row.NRPEDIDOCOL       = info.NRPEDIDOCOL;
        row.CDFILIAL          = info.CDFILIAL;
        return restEngine.post("sup_cotacao_pedido#/salvarComentario", {
          	"requestType": "Row",
			"row": row
		});
	};
	
	
	this.deletePedido = function(dataset) {
        return restEngine.post('sup_cotacao_pedido#/deletePedido', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup03600PedidoColetaService', Sup03600PedidoColetaService);
});