function Sup00800AfsInconsistenteForaLimiteController(ScreenService, MessageService, templateManager, General) {
    this.setDataEntregaDefault = function(widget) {
        if (Util.isEmptyOrBlank(widget.currentRow.DATAENTREGA)) {
            widget.currentRow.DATAENTREGA = { 
                'formattedStart': moment().format('L'),
                'formattedEnd': moment().format('L'), 
                'start': moment().format('L'), 
                'end': moment().format('L') 
            };
        }
    };
    
    this.verificaAgrupamento = function(field) {
        if (field.widget.getField('NMGRUPFILI').value()) {
            field.dataSource.name = "cmp_fornecimento_emissaoAF#/crud/filial_por_agrupamento";
            field.dataSourceFilter = [{
                "name": "P_CDGRUPFILI",
                "operator": "=",
                "value": field.widget.currentRow.CDGRUPFILI
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
            ];
        } else {
            field.dataSource.name = "cmp_fornecimento_emissaoAF#/crud/filial_sem_agrupamento";
            field.dataSourceFilter = [{
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }];
        }
        
        field.reload();
    };
    
    this.criaRelatorio = function(widget) {
        var reportName = widget.currentRow.RELATORIO;
        if (widget.isValid()) {
            var row = Util.clone(widget.currentRow);
           

            row.P_DATAINI1 = row.DATAENTREGA.start;
            row.P_DATAINI2 = row.DATAENTREGA.start;
            row.P_DATAFIN1 = row.DATAENTREGA.end;
            row.P_DATAFIN2 = row.DATAENTREGA.end;
            row.P_NRAUTOFORN1 = 'T';
            row.P_NRAUTOFORN2 = 'T';
            row.P_CDOPERADOR = getLocalVar('CDOPERADOR');
            row.P_CDGRUPFILI1 = widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T';
            row.P_CDGRUPFILI2 = widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T';
            row.L_CDFILDEST1 = !Util.isEmptyOrBlank(widget.getField('CDFILIAL').value()) ? widget.getField('CDFILIAL').value().join("_") : 'T'; // Filtro de filial. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDFILDEST2 = !Util.isEmptyOrBlank(widget.getField('CDFILIAL').value()) ? widget.getField('CDFILIAL').value().join("_") : 'T'; // Filtro de filial. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDFILDEST3 = !Util.isEmptyOrBlank(widget.getField('CDFILIAL').value()) ? widget.getField('CDFILIAL').value().join("_") : 'T'; // Filtro de filial. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDFILDEST4 = !Util.isEmptyOrBlank(widget.getField('CDFILIAL').value()) ? widget.getField('CDFILIAL').value().join("_") : 'T'; // Filtro de filial. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDREGIAO1 = !Util.isEmptyOrBlank(widget.getField('CDREGIAO').value()) ? widget.getField('CDREGIAO').value().join("_") : 'T'; // Filtro de região. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDREGIAO2 = !Util.isEmptyOrBlank(widget.getField('CDREGIAO').value()) ? widget.getField('CDREGIAO').value().join("_") : 'T'; // Filtro de região. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDOPERADOR1 = !Util.isEmptyOrBlank(widget.getField('CDOPERADOR').value()) ? widget.getField('CDOPERADOR').value().join("_") : 'T'; // Filtro de operador. Passar os selecionados concatenados em um string e separados por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDOPERADOR2 = !Util.isEmptyOrBlank(widget.getField('CDOPERADOR').value()) ? widget.getField('CDOPERADOR').value().join("_") : 'T'; // Filtro de operador. Passar os selecionados concatenados em um string e separados por underline. caso o filtro esteja vazio passar 'T'
            row.P_NRORG = getLocalVar('NRORG');

            General.openReportPopup(widget, this.abreRelatorio, [widget, row, reportName]);
        } else {
            MessageService.showMessageByCode("cmp#TODOS_CAMPOS_OBRIGATORIOS"); 
        }
    };
    
    this.abreRelatorio = function(widget, row, reportName) {
        row.QR2TYPE = templateManager.container.getActiveWidget().currentRow.QR2TYPE;
        General.openReport('cmp_fornecimento_emissaoAF#/sup00800_relatorio', reportName, row); 
    };
    
    this.onChangeAgrupamento = function(){
        var field = templateManager.container.getWidget('inconsistente_fora_limite').getField('CDFILIAL');
        field.clearValue();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup00800AfsInconsistenteForaLimiteController', Sup00800AfsInconsistenteForaLimiteController);
});
